package org.processmining.models.animation;

import java.util.ArrayList;
import java.util.List;

public class EdgeAnimationKeyframe {
	private long time;
	private long lastCompleted;
	private int traverseCount;

	private List<TokenAnimation> tokenAnimations;

	public EdgeAnimationKeyframe(long time) {
		this.time = time;
		this.lastCompleted = -1;
		this.traverseCount = -1;
		this.tokenAnimations = new ArrayList<TokenAnimation>();
	}

	public void addTokenAnimation(TokenAnimation anim) {
		long animEnd = anim.getEnd();
		for (int i = tokenAnimations.size(); i > 0; i--) {
			if (tokenAnimations.get(i - 1).getEnd() < animEnd) {
				tokenAnimations.add(i, anim);
				return;
			}
		}
		tokenAnimations.add(0, anim);
	}

	public void setLastCompleted(long lastCompleted) {
		this.lastCompleted = lastCompleted;
	}

	public void setTraverseCount(int traverseCount) {
		this.traverseCount = traverseCount;
	}

	public long getTime() {
		return time;
	}

	public long getLastCompleted() {
		return lastCompleted;
	}

	public int getTraverseCount() {
		return traverseCount;
	}

	public List<TokenAnimation> getTokenAnimations() {
		return tokenAnimations;
	}
}
