package org.processmining.models.animation;

import org.deckfour.xes.model.XTrace;

public class NodeAnimationKeyframe {
	private XTrace trace;
	private long time;
	private int eventCount;
	private int emergeCount;
	private int swallowCount;

	public NodeAnimationKeyframe(XTrace trace, long time, boolean emerged, boolean swallowed) {
		this.trace = trace;
		this.time = time;
		this.eventCount = 0;
		this.emergeCount = 0;
		this.swallowCount = 0;
		if (emerged) {
			this.emergeCount++;
		}
		if (swallowed) {
			this.swallowCount++;
		}
	}

	public void setEventCount(int eventCount) {
		this.eventCount = eventCount;
	}

	public XTrace getTrace() {
		return trace;
	}

	public long getTime() {
		return time;
	}

	public int getEventCount() {
		return eventCount;
	}

	public int getEmergeCount() {
		return emergeCount;
	}

	public int getSwallowCount() {
		return swallowCount;
	}

	public void setEmergeCount(int emergeCount) {
		this.emergeCount = emergeCount;
	}

	public void setSwallowCount(int swallowCount) {
		this.swallowCount = swallowCount;
	}

	public int compareTo(NodeAnimationKeyframe o) {
		if (time > o.time) {
			return 1;
		} else if (time < o.time) {
			return -1;
		} else {
			return 0;
		}
	}

}
