package org.processmining.models.animation;

import org.deckfour.xes.model.XTrace;

public class TokenAnimation {
	private XTrace trace;
	private long start;
	private long end;

	public TokenAnimation(XTrace trace, long start, long end) {
		this.trace = trace;
		this.start = start;
		this.end = end;
	}

	public XTrace getTrace() {
		return trace;
	}

	public long getStart() {
		return start;
	}

	public long getEnd() {
		return end;
	}

	public float completedPercentage(long time) {
		if (time <= start) {
			return 0f;
		} else if (time >= end) {
			return 1f;
		} else {
			return (float) (time - start) / (float) (end - start);
		}
	}

	public boolean equals(Object o) {
		if (o instanceof TokenAnimation) {
			TokenAnimation other = (TokenAnimation) o;
			return start == other.start && end == other.end && trace.equals(other.trace);
		} else {
			return false;
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		return (trace.hashCode() << 2) + (int) (end - start);
	}

}
