package org.processmining.models.animation.visualization;

import java.text.DecimalFormat;

import org.processmining.models.animation.Animation;

public class ActivityMeter extends AnimationMeter {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7395095025773952121L;
	protected DecimalFormat format = new DecimalFormat("##0 %");

	/**
	 * @param anim
	 * @param name
	 */
	public ActivityMeter(Animation anim) {
		super(anim, "Activity");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.processmining.mining.fuzzymining.vis.ui.AnimationMeter#update(long)
	 */
	@Override
	protected void update(long modelTime) {
		long maxTaskDelay = modelTime - getAnimation().getFadeTime();
		float activity = getAnimation().getActivity(modelTime, maxTaskDelay);
		if (activity < 0f) {
			activity = 0f;
		} else if (activity > 1f) {
			activity = 1f;
		}
		this.setState(activity, format.format(activity));
	}

}
