package org.processmining.models.animation.visualization.painters;

import java.awt.Graphics2D;
import java.util.List;

import org.processmining.models.animation.AnimationCurve;
import org.processmining.models.animation.EdgeAnimation;
import org.processmining.models.animation.EdgeAnimationKeyframe;
import org.processmining.models.animation.TokenAnimation;
import org.processmining.models.animation.visualization.AnimationCanvas;

public class TokenLabelPainter extends Painter {

	public TokenLabelPainter(AnimationCanvas canvas) {
		super(canvas);
		// TODO Auto-generated constructor stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.processmining.mining.fuzzymining.vis.paint.Painter#paint(long,
	 * java.awt.Graphics2D)
	 */
	@Override
	public void paint(long modelTime, Graphics2D g2d) {
		g2d.setColor(canvas.getColorSettings().getTokenLabel());
		double offset = canvas.translateY(canvas.getBoxHeight()) * 0.4f;
		double fontSize = (canvas.getFontSize() * 1.2f);
		g2d.setFont(g2d.getFont().deriveFont((float) fontSize));
		EdgeAnimationKeyframe keyframe = null;
		AnimationCurve curve = null;
		List<EdgeAnimation> animations = canvas.getAnimation().getEdgeAnimations();
		for (EdgeAnimation anim : animations) {
			keyframe = anim.getKeyframe(modelTime);
			curve = anim.getCurve();
			// derive stroke color from idle time and set
			for (TokenAnimation tokenAnim : keyframe.getTokenAnimations()) {
				double[] pos = curve.getRelativePoint(tokenAnim.completedPercentage(modelTime));
				double x = canvas.translateX(pos[0]) + offset;
				double y = canvas.translateY(pos[1]) + (fontSize / 2f);
				canvas.getAnimation().paintTokenLabel(anim.getEdge(), tokenAnim.getTrace(), g2d, x, y);
			}
		}
	}

}
